# The Powershell script returns a particular attribute about the Public Folders


Function Main()
{
    $PWD = "##Automation--LoginPassword--##"
    $Email = "##Automation--LoginUser--##"
    $Attribute = '##Automation--Attribute--##'
    $HashAlgo = '##Automation--HashAlgo--##'

    $SecurePassword = ConvertTo-SecureString -String $PWD -AsPlainText -Force

    $Credential = New-Object -TypeName "System.Management.Automation.PSCredential" -ArgumentList $Email, $SecurePassword

	# $Session = New-PSSession -ConfigurationName Microsoft.Exchange -ConnectionUri https://outlook.office365.com/powershell-liveid/ -Credential $Credential -Authentication Basic -AllowRedirection

    # Import-PSSession $Session -DisableNameChecking -AllowClobber | Out-Null

	# Connect-AzureAD -Credential $Credential | Out-Null

    Connect-ExchangeOnline -Credential $Credential -ShowBanner:$false

    $folder_IDs = Get-PublicFolder \ -GetChildren | Select-Object $Attribute

#	Remove-PSSession $Session

	if ($HashAlgo)
	{
        $hasher = [System.Security.Cryptography.HashAlgorithm]::Create($HashAlgo)

        $res = New-Object System.Collections.Generic.List[System.Object]

        For($i=0; $i -lt $folder_IDs.length; $i++){
        $hash = $hasher.ComputeHash([System.Text.Encoding]::UTF8.GetBytes($folder_IDs[$i].$Attribute))
        $hashString = [System.BitConverter]::ToString($hash)

        $hashValue = $hashString.Replace('-','')
        $res.Add($hashValue)

        }
        return $res.ToArray()
	}
    else
    {
        return $folder_IDs
    }
}



